services:
  docker-socket-proxy:
    image: registry.gitlab.com/naturalis/lib/docker/docker-socket-proxy:${DOCKERPROXY_VERSION:-latest}
    container_name: "${COMPOSE_PROJECT_NAME:-composeproject}_docker-socket-proxy"
    restart: unless-stopped
    networks:
      - docker-socket-proxy
    volumes:
      - /var/run/docker.sock:/var/run/docker.sock:ro,delegated
    environment:
      CONTAINERS: 1  

  traefik:
    image: registry.gitlab.com/naturalis/lib/docker/traefik:${TRAEFIK_VERSION:?err}
    container_name: "${COMPOSE_PROJECT_NAME:-composeproject}_traefik"
    restart: ${CONTAINER_RESTART:-unless-stopped}
    depends_on:
      - docker-socket-proxy
    networks:
      - public
      - docker-socket-proxy
    ports:
      - "${HOST_IP:-0.0.0.0}:80:80"
      - "${HOST_IP:-0.0.0.0}:443:443"
    volumes:
      - "./letsencrypt:/letsencrypt"
      - "./traefik/traefik-dynamic-config.toml:/traefik-dynamic-config.toml"
    command:
      - "--global.sendAnonymousUsage=false"
      - "--log.level=${TRAEFIK_LOG_LEVEL:-ERROR}"
      - "--entrypoints.web.address=:80"
      - "--entrypoints.web.http.redirections.entrypoint.to=websecure"
      - "--entrypoints.web.http.redirections.entrypoint.scheme=https"
      - "--entrypoints.web.http.redirections.entrypoint.permanent=true"
      - "--entrypoints.websecure.address=:443"
      - "--certificatesresolvers.route53.acme.dnschallenge=true"
      - "--certificatesresolvers.route53.acme.dnschallenge.provider=route53"
      - "--certificatesresolvers.route53.acme.storage=/letsencrypt/route53.json"
      - "--providers.docker=true"
      - "--providers.docker.exposedbydefault=false"
      - "--providers.docker.endpoint=tcp://docker-socket-proxy:2375"
      - "--providers.docker.network=docker-socket-proxy"
      - "--providers.file.filename=/traefik-dynamic-config.toml"
    env_file:
      - .env

  homepage:
    image: "registry.gitlab.com/naturalis/bii/ai/naturalis-ai/\
      ${RELEASE:?No tag or branch provided, RELEASE is empty}/\
      web:${AI_WEB_VERSION:?No AI_WEB_VERSION provided}"
    container_name: "${COMPOSE_PROJECT_NAME:-composeproject}_homepage"
    restart: always
    networks:
      - public
    ports:
      - 8058:8058
    labels:
      - "traefik.enable=true"
      - "traefik.http.routers.homepage.entrypoints=websecure"
      - "traefik.http.routers.homepage.rule=${API_SITE_URL:-Host(`replace.me.dryrun.link`)} && Path(`/`)"
      - "traefik.http.routers.homepage.tls.certresolver=route53"

networks:
  public:
    internal: false
  docker-socket-proxy:
    internal: true
